<?php
if ( !defined( 'IN_CMS' ) ) {
    exit();
}

\IoC::resolve( 'eventmediator' )->attach( 'before_route', function( FastRoute\RouteCollector $r, $request, $response ) {
    $r->get( 'polls/poll/list', 'plugins\\polls\controllers\\PollController@list' );
    $r->get( 'polls/poll/add', 'plugins\\polls\controllers\\PollController@addform' );
    $r->post( 'polls/poll/add', 'plugins\\polls\controllers\\PollController@add' );
    $r->get( 'polls/poll/update/{id:\\d+}', 'plugins\\polls\controllers\\PollController@updateform' );
    $r->post( 'polls/poll/update/{id:\\d+}', 'plugins\\polls\controllers\\PollController@update' );
    $r->get( 'polls/poll/delete/{id:\\d+}', 'plugins\\polls\controllers\\PollController@delete' );
    $r->post( 'polls/vote/{id:\\d+}', 'plugins\\polls\controllers\\VoteController@add' );
    $r->get( 'polls/poll/show/{id:\\d+}', 'plugins\\polls\controllers\\PollController@show' );
    $r->get( 'polls/vote/clear/{id:\\d+}', 'plugins\\polls\\controllers\\VoteController@clear' );
    return true;
} );

\IoC::resolve( 'eventmediator' )->attach( 'after_initialize_backend_menu', function( library\BackendMenu $backendMenu ) {
    $backendMenu->push( ['name' => 'polls', 'url' =>  BASE_URL . 'polls/poll/list'] );
    return true;
} );

\IoC::resolve( 'eventmediator' )->attach( 'check_template_used', function( $template, &$isUsed ) {
    $settings = \IoC::resolve( 'settings' );
    if ( $settings['polls.poll_template'] == $template->template_id ) {
        $isUsed = true;
        return false;
    }
    return true;
} );

$logger = \IoC::resolve( 'logger' );
$logger->write( sprintf( '[%s] [%s] [%s] Plugin polls initialized.', date( 'Y-m-d H:i:s' ), __FILE__, 'info' ) );
